import os  
import struct

def write_uint32(f, value:int):
  f.write(struct.pack('<I', value))     

def read_uint32(f):
  return struct.unpack('<I', f.read(4))[0]

def update_arm9_size(game_iso_path:str, compressed_arm9_path:str, decompressed_arm9_path:str):
  with open(game_iso_path, 'rb') as f:
      f.seek(0x28)
      load = read_uint32(f)
      f.seek(0x70)
      auto = read_uint32(f) - load

  arm9_comp_size = os.path.getsize(compressed_arm9_path)
  arm9_decomp_size = os.path.getsize(decompressed_arm9_path)
  with open(compressed_arm9_path, 'r+b') as f:
      f.seek(auto - 4)
      offset = read_uint32(f) - load
      print(f'Offset: {offset}')

      #1st value to update
      f.seek(offset)
      val1 = load + arm9_decomp_size - 0x18
      print(f'val1: {hex(val1)}')
      write_uint32(f, val1)

      #2nd value to update
      f.seek(offset + 1*4)
      val2 = load + arm9_decomp_size
      print(f'val2: {hex(val2)}')
      write_uint32(f, val2)

      #3rd value to update
      f.seek(offset + 5*4)
      val3 = load + arm9_comp_size
      print(f'val3: {hex(val3)}')
      write_uint32(f, val3)
